//************************************************************************************
//**  
//**  File name:     H:\SRC\FlowCode\Led7seg4.c
//**  Generated by:  Flowcode v4.4.13.69
//**  Date:          Sunday, November 11, 2012 23:09:42
//**  Licence:       Professional
//**  Registered to: Jacek Bogusz
//**  
//**  
//**  http://www.matrixmultimedia.com
//************************************************************************************


#define MX_PIC_16BIT

//Defines for microcontroller
#define dsPIC33
#define P33FJ32GP202
#define MX_CLKS_PER_INST 2
#define MX_SPI1
#define MX_SPI1_PORT_FREEALLOC
#define MX_UART1
#define MX_UART1_PORT_FREEALLOC
#define MX_MI2C1
#define MX_I2C1_PORT_B
#define MX_I2C1_SDA 9
#define MX_I2C1_SCL 8
#define MX_PWM
#define MX_PWM_PORT_FREEALLOC
#define MX_PWM_CNT 2
#define MX_PWM_1 0
#define MX_PWM_2 1

//Functions
#define MX_Fosc 12000000

#include "../support/dsPIC33F/h/p33Fxxxx.h"
#include <stdlib.h>
#include <math.h>

//Configuration data
_FBS(0xf)  //addr = 0xf80000
_FGS(0x7)  //addr = 0xf80004
_FOSCSEL(0x82)  //addr = 0xf80006
_FOSC(0xa2)  //addr = 0xf80008
_FWDT(0x5f)  //addr = 0xf8000a
_FPOR(0xf7)  //addr = 0xf8000c
_FICD(0xc3)  //addr = 0xf8000e

//Internal functions
#include "C:\Program Files (x86)\Matrix Multimedia\Flowcode PIC24&dsPIC V4\FCD\internals.h"

//Macro function declarations
void FCM_Wyswietlanie();


//Variable declarations
volatile char FCV_CYFRA1000;
volatile char FCV_CYFRA1;
volatile char FCV_LICZNIK;
volatile char FCV_CYFRA100;
volatile char FCV_CYFRA10;


//Defines:

/**** Macro Substitutions ****
B = Segment Port
B = Common Port
49152 = Pattern 0
63744 = Pattern 1
41984 = Pattern 2
45056 = Pattern 3
39168 = Pattern 4
37376 = Pattern 5
33280 = Pattern 6
63488 = Pattern 7
32768 = Pattern 8
38912 = Pattern 9
32767 = Pattern DP
1 = Common Anode
65520 = Common Mask Inverted
255 = Segment Mask Inverted
8 = Common Pin 0
4 = Common Pin 1
2 = Common Pin 2
1 = Common Pin 3
******************************/




//led7seg4(0): //Macro function declarations

static void FCD_led7seg40_ShowDigit(char Digit, char Value, char DecimalPoint);



//led7seg4(0): //Macro implementations


static void FCD_led7seg40_ShowDigit(char Digit, char Value, char DecimalPoint)
{
	
		#define MX_7SEG4_SEGMENT_PORT  LATB
		#define MX_7SEG4_SEGMENT_TRIS  TRISB

		#define MX_7SEG4_COMMON_PORT   LATB
		#define MX_7SEG4_COMMON_TRIS   TRISB

		if (Digit <= 3)
		{
			//set pattern arrays for the display
			const unsigned int cCommonArray[] = {8, 4, 2, 1};
			const unsigned int cSegmentArray[] = {49152, 63744, 41984, 45056, 39168, 37376, 33280, 63488, 32768, 38912};

			//get pattern for digit
			unsigned int cSegmentValue = cSegmentArray[Value % 10];
			if (DecimalPoint) cSegmentValue = cSegmentValue & 32767;

			//set up ports
			MX_7SEG4_COMMON_TRIS = MX_7SEG4_COMMON_TRIS & 65520;
			MX_7SEG4_SEGMENT_TRIS = MX_7SEG4_SEGMENT_TRIS & 255;
			//MX_7SEG4_COMMON_PORT = MX_7SEG4_COMMON_PORT & 65520;

			#define MX_7SEG_COM_ANODE_1

			//display the digit
	    	#ifdef MX_7SEG_COM_ANODE_1
				//common anode
				MX_7SEG4_SEGMENT_PORT = cSegmentValue;
				MX_7SEG4_COMMON_PORT = (MX_7SEG4_COMMON_PORT & 65520) | cCommonArray[Digit];
			#else
				//common cathode
				MX_7SEG4_SEGMENT_PORT = (MX_7SEG4_SEGMENT_PORT | ~255) & ~cSegmentValue;
				MX_7SEG4_COMMON_PORT = (MX_7SEG4_COMMON_PORT | ~65520) & ~cCommonArray[Digit];
			#endif
		}

		#undef MX_7SEG4_COMMON_PORT
	    #undef MX_7SEG4_COMMON_TRIS
	    #undef MX_7SEG_COM_ANODE_1

}

//Macro implementations

void FCM_Wyswietlanie()
{
	//Makro wy?wietlaj?ce cyfr? po cyfrze w procedurze obs?ugi przerwania od Timera 1.
	
	//Zwi?kszenie licznika
	//Calculation:
	//  Licznik = Licznik+1
	FCV_LICZNIK = FCV_LICZNIK+1;
	

	//Ktra cyfra?
	//Switch: Licznik?
	switch (FCV_LICZNIK)
	{
		case 1:
		{
			//Wy?wietlanie cyfry nr 1
			//Call Component Macro: led7seg4(0)::ShowDigit(3, Cyfra1000, 0)
			FCD_led7seg40_ShowDigit(3, FCV_CYFRA1000, 0);


			break;
		}

		case 2:
		{
			//Wy?wietlanie cyfry nr 2
			//Call Component Macro: led7seg4(0)::ShowDigit(2, Cyfra100, 0)
			FCD_led7seg40_ShowDigit(2, FCV_CYFRA100, 0);


			break;
		}

		case 3:
		{
			//Wy?wietlanie cyfry nr 3
			//Call Component Macro: led7seg4(0)::ShowDigit(1, Cyfra10, 0)
			FCD_led7seg40_ShowDigit(1, FCV_CYFRA10, 0);


			break;
		}

		case 4:
		{
			//Wy?wietlanie cyfry nr 4
			//Call Component Macro: led7seg4(0)::ShowDigit(0, Cyfra1, 0)
			FCD_led7seg40_ShowDigit(0, FCV_CYFRA1, 0);


			//Zerowanie licznika
			//Calculation:
			//  Licznik = 0
			FCV_LICZNIK = 0;
			

			break;
		}

		default:
		{
			//Zerowanie licznika
			//Calculation:
			//  Licznik = 0
			FCV_LICZNIK = 0;
			

		}
	}


}

int main()
{
	
	//Initialisation
	AD1PCFGL = 0xffff;


	//Interrupt initialisation code
	
	//Podstawienie liczb
	//Calculation:
	//  Cyfra1 = 9
	//  Cyfra10 = 7
	//  Cyfra100 = 5
	//  Cyfra1000 = 3
	FCV_CYFRA1 = 9;
	FCV_CYFRA10 = 7;
	FCV_CYFRA100 = 5;
	FCV_CYFRA1000 = 3;
	

	//Przerwanie od Timera
	//Interrupt: Enable TMR1
	T1CON = ((T1CON & 0xfffd) | 0x8000);
	T1CON &= 0xff0f;
	PR1 = 16384-1;
	IEC0bits.T1IE = 1;


	//P?tla niesko?czona
	//Loop: While 1
	while (1)
	{
	}


	mainendloop: goto mainendloop;
	return 0;
}

	//Handler code for [TMR1]
	void _ISR _T1Interrupt(void)
	{
		IFS0bits.T1IF = 0;
		FCM_Wyswietlanie();
	}




